# Algorithme Min Max et Monte Carlo

## Description du projet

Nous essayons ici d'implémenter les algorithmes de Monte Carlo et min max pour le jeu Ultimate Tic-tac-Toe afin de créer une IA intelligente. Le jeu Tic-tac-toe a été créé par les 
professeurs, il ne nous restait plus qu'à nous documenter sur ces deux algorithmes particulier afin de pouvoir les implémenter dans le cadre de notre projet.

## Liste des membres du projet

TRAN Alain -> travaille sur la branche MinMax_Alain sur l'algorithme Min-Max.  
CRESCENCE Cassandre -> travaille sur la branche mcts_Cassandre sur l'algorithme Monte Carlo.  
MACE Lloyd -> travaille sur la branche mcts_lloyd sur l'algorithme Monte-Carlo.

## Consignes d'installation et d'exécution 

Le code est écrit en Java (sur la plateforme Netbeans). Pour pouvoir visualiser et tester le programme, il suffit néanmoins de posséder une ide capable de lire du Java (Netbeans,
Eclipse...)

### Pour exécuter l'algorithme de MCTS

Pour que le joueur ordinateur joue selon l'algorithme de MCTS, il faut modifier la classe `Player`:

    AlgoRechercheMCTS alea  = new AlgoRechercheMCTS(joueurOrdi); 
    joueurOrdi.setAlgoRecherche(alea);     
    
     GrilleTicTacToe9x9 grille = new GrilleTicTacToe9x9();
    


#### Pour le TicTacToe 3x3

Il suffit de modifier la grille utilisée de la classe `Player` :


    
    GrilleTicTacToe3x3 grille = new GrilleTicTacToe3x3(); 
    
    


#### Pour le TicTacToe 9x9

Il suffit de modifier la grille utilisée de la classe `Player` :


    
    GrilleTicTacToe9x9 grille = new GrilleTicTacToe9x9(); 
    
    


### Pour exécuter l'alrogithme MinMax

#### Pour le TicTacToe 3x3

#### Pour le TicTacToe 9x9

Pour que le joueur ordinateur joue selon l'algorithme de MCTS, il faut modifier la classe `Player`:

    
    AlgoRechercheMinMax_9x9 alea  = new AlgoRechercheMinMax_9x9(joueurOrdi, humain); 
    joueurOrdi.setAlgoRecherche(alea);
    
    GrilleTicTacToe9x9 grille = new GrilleTicTacToe9x9(); 
    
    


## Porte d'entrée dans le code

Pour accéder aux codes de chacun (non finis pour l'instant), il suffit d'aller sur chaque branche attitrée et d'aller dans le SRC.
Pour Lloyd et Cassandre, les classes sont dans le Repository mcts_cassandre ou mcts_lloyd.
Pour Alain, il faut aller dans src et dans le Repository initial TicTacToecodeingame et chercher le tout dans la classe AlgoRechercheMinMax.
Il sera possible d'accéder à ces deux algorithmes dans le master une fois qu'ils seront implémenter correctement et qu'ils marcheront.

## Les pistes d'améliorations 

### Pour l'algorithme MCTS 

Comme première piste d'amélioration du temps d'exécution de l'algorithme, nous pouvons utiliser une technique heuristique améliorant l'étape de simulation. En effet, au lieu de lancer des simulations aléatoires, nous pouvons lancer des simulations qui seront optimisées à partir des simulations précédentes.
Une technique connue appelé RAVE ( Rapid action value estimation) permet d'optimiser l'étape de simulations. Pour l'implémenter, il faut ajouter de nouveaux paramètres qui considèrent la statistique des victoires associée  à chaque noeud en prenant également en compte le moment où le coup associé a été joué.
Ces paramètres permettront de réécrire la formule de l'UCT (Upper Confidence Bound 1 applied to Trees) sous une autre forme qui prendra en compte ces nouveaux critères statistiques.

### Pour l'algorithme Minmax

Pour l'algorithme de Minmax, nous pouvons élaborer la technique d'élagage Alpha-bêta qui va permettre de réduire le nombre de noeud à visiter et ainsi optimiser le temps d'exécution de l'algorithme. 